'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsPromise = require('fs-promise');

var _fsPromise2 = _interopRequireDefault(_fsPromise);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileRepository = function () {
  function FileRepository() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, FileRepository);

    if (!options.folderPath) {
      throw new Error('repositoryOptions.folderPath is undefined');
    }
    this.folderPath = options.folderPath;
    this.idCounter = 0;
  }

  _createClass(FileRepository, [{
    key: 'add',
    value: function add(newData) {
      if (!_fs2.default.existsSync(this.folderPath)) {
        _fs2.default.mkdirSync(this.folderPath);
      }

      newData.__id = this.idCounter;
      this.idCounter++;
      return _fsPromise2.default.writeFile(this._getPath(newData.__id), JSON.stringify(newData)).then(function () {
        return newData;
      });
    }
  }, {
    key: 'get',
    value: function get(id) {
      return _fsPromise2.default.readFile(this._getPath(id), 'utf-8').then(function (stringData) {
        return JSON.parse(stringData);
      });
    }
  }, {
    key: 'getAll',
    value: function getAll() {
      var _this = this;

      if (!_fs2.default.existsSync(this.folderPath)) {
        return Promise.resolve([]);
      }

      return _fsPromise2.default.readdir(this.folderPath).then(function (files) {
        var promises = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var fileName = _step.value;

            promises.push(_this.get(fileName.split('.')[0]));
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return Promise.all(promises);
      });
    }
  }, {
    key: 'delete',
    value: function _delete(id) {
      return _fsPromise2.default.unlink(this._getPath(id));
    }
  }, {
    key: 'update',
    value: function update(id, newData) {
      return _fsPromise2.default.writeFile(this._getPath(id), JSON.stringify(newData)).then(function () {
        return newData;
      });
    }
  }, {
    key: '_getPath',
    value: function _getPath(id) {
      return this.folderPath + '/' + id + '.json';
    }
  }]);

  return FileRepository;
}();

exports.default = FileRepository;